use std::fs;

use scan_fmt::scan_fmt;

pub fn solve() {
    let path = "res/13/input";

    #[allow(unused)]
    let contents = fs::read_to_string(path).expect("Something went wrong reading the file");

    let machines: Vec<((isize, isize), (isize, isize), (isize, isize))> = contents
        .split("\n\n")
        .map(|block| {
            let (x1, y1, x2, y2, xt, yt) = scan_fmt!(
                block,
                "Button A: X+{}, Y+{}\nButton B: X+{}, Y+{}\nPrize: X={}, Y={}",
                isize,
                isize,
                isize,
                isize,
                isize,
                isize
            )
            .unwrap();
            ((x1, y1), (x2, y2), (xt, yt))
        })
        .collect();

    let result: isize = machines
        .iter()
        .map(|m| {
            let ((ax, ay), (bx, by), (xt, yt)) = *m;
            let (mut a, mut b) = (0, 0);
            while b * bx < xt && b * by < yt {
                b += 1;
            }
            while (b * bx + a * ax != xt || b * by + a * ay != yt) && b > 0 {
                b -= 1;
                while b * bx + a * ax < xt && b * by + a * ay < yt {
                    a += 1;
                }
            }

            if b * bx + a * ax == xt && b * by + a * ay == yt {
                return b + a * 3;
            }

            return 0;
        })
        .sum();

    println!("Result 1: {}", result);

    let result: isize = machines
        .iter()
        .map(|m| {
            let ((ax, ay), (bx, by), (xt, yt)) = *m;
            let xt = xt + 10000000000000;
            let yt = yt + 10000000000000;

            let b_left = by * ax - bx * ay;
            let b_right = yt * ax - xt * ay;
            let b = b_right / b_left;
            if b_left * b != b_right || b < 0 {
                return 0;
            }

            let a_left = ax;
            let a_right = xt - b * bx;
            let a = a_right / a_left;
            if a_left * a != a_right || a < 0 {
                return 0;
            }
            a * 3 + b
        })
        .sum();

    println!("Result 2: {}", result);
}
